source/source/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('webapp.urls', namespace='webapp'))
]

source/webapp/urls.py
from django.urls import path
from django.conf.urls.static import static
from django.conf import settings
from webapp.views import BookCreateView, BookDetailView, BookListView, BookDeleteView, \
    BookUpdateView, OrderListView, OrderDetailView, PublisherDetailView, \
    PublisherListView, OrderUpdateView, OrderCreateView, PublisherCreateView, PublisherDeleteView, PublisherUpdateView, RequestListView, \
    RequestDetailView, RequestCreateView, RequestBookCreateView


app_name = 'webapp'

urlpatterns = [
    path('', BookListView.as_view(), name='book_list'),
    path('book/<int:pk>', BookDetailView.as_view(), name='book_detail'),
    path('book/create', BookCreateView.as_view(), name='book_create'),
    path('book/update/<int:pk>', BookUpdateView.as_view(), name='book_update'),
    path('book/delete/<int:pk>', BookDeleteView.as_view(), name='book_delete'),
    path('order/<int:pk>', OrderDetailView.as_view(), name='order_detail'),
    path('order/create', OrderCreateView.as_view(), name='order_create'),
    path('order/<int:pk>/update', OrderUpdateView.as_view(), name='order_update'),
    path('orders', OrderListView.as_view(), name='order_list'),
    path('publisher/<int:pk>', PublisherDetailView.as_view(), name='publisher_detail'),
    path('publishers', PublisherListView.as_view(), name='publisher_list'),
    path('publisher/create', PublisherCreateView.as_view(), name='publisher_create'),
    path('publisher/update/<int:pk>', PublisherUpdateView.as_view(), name='publisher_update'),
    path('publisher/delete/<int:pk>', PublisherDeleteView.as_view(), name='publisher_delete'),
    # path('order/<int:pk>/book/create', OrderBookCreateView.as_view(), name='order_book_create'),
    # path('order/book/<int:pk>/update', OrderBookUpdateView.as_view(), name='order_book_update'),
    # path('order/book/<int:pk>/delete', OrderBookDeleteView.as_view(), name='order_book_delete'),
    path('request/<int:pk>', RequestDetailView.as_view(), name='request_detail'),
    path('requests', RequestListView.as_view(), name='request_list'),
    path('request/create', RequestCreateView.as_view(), name='request_create'),
    path('request/<int:pk>/book/create', RequestBookCreateView.as_view(), name='request_book_create')
]

source/webapp/models.py
from django.db import models


class Publisher(models.Model):
    name = models.CharField(max_length=50, verbose_name="Издатель")
    phone = models.CharField(max_length=20, verbose_name="Телефон")

    def __str__(self):
        return self.name

class Book(models.Model):

    TYPE_EBOOK = 'Электронная версия'
    TYPE_PBOOK = 'Бумажная книга'

    TYPE_CHOICES = (
        (TYPE_EBOOK, 'e-version'),
        (TYPE_PBOOK, 'print version')
    )

    title = models.CharField(max_length=200, verbose_name="Название")
    description = models.TextField(max_length=1000, null=True, blank=True, verbose_name='Описание')
    type = models.CharField(max_length=50, default=TYPE_PBOOK, choices=TYPE_CHOICES, verbose_name='Статус')
    author = models.CharField(max_length=200, verbose_name="Автор")
    link = models.CharField(max_length=200, blank=True, verbose_name="Ссылка")
    amount = models.IntegerField(blank=True, verbose_name="Количество")
    publisher = models.ForeignKey(Publisher, blank=True, related_name='books', on_delete=models.PROTECT)

    def __str__(self):
        return self.title
class Request(models.Model):

    STATUS_NEW = 'На рассмотрении'
    STATUS_OK = 'Одобрена'
    STATUS_NO = 'Отклонена'

    STATUS_CHOICES = (
        (STATUS_NEW, 'На рассмотрении'),
        (STATUS_OK, 'Одобрена'),
        (STATUS_NO, 'Отклонена')
    )

    TYPE_WRITEDOWN = 'На списание'
    TYPE_PURCHASE = 'На закупку'

    TYPE_CHOICES = (
        (TYPE_WRITEDOWN, 'На списание'),
        (TYPE_PURCHASE, 'На закупку')
    )

    type = models.CharField(max_length=20, default=TYPE_PURCHASE, choices=TYPE_CHOICES)
    status = models.CharField(max_length=20, default=STATUS_NEW, choices=STATUS_CHOICES)

    def __str__(self):
        return self.id

class RequestBook(models.Model):
    request = models.ForeignKey(Request, related_name='request_books', verbose_name='Заявка', on_delete=models.CASCADE)
    book = models.ForeignKey(Book, related_name='request_books', verbose_name='Книга', on_delete=models.CASCADE)
    amount = models.IntegerField(blank=True, default=1, verbose_name="Количество")

    def __str__(self):
        return self.book.title

class Order(models.Model):

    STATUS_NEW = 'Новый'
    STATUS_DELIVERED = 'Принят'
    STATUS_CANCELED = 'Отменён'

    STATUS_CHOICES = (
        (STATUS_NEW, 'Новый'),
        (STATUS_DELIVERED, 'Принят'),
        (STATUS_CANCELED, 'Отменён')
    )

    status = models.CharField(max_length=20, default=STATUS_NEW, verbose_name='Статус', choices=STATUS_CHOICES)
    publisher = models.ForeignKey(Publisher, blank=True, null=True, related_name='orders', on_delete=models.PROTECT)
    book = models.ManyToManyField(RequestBook, related_name='order_books', verbose_name='Книга')

    def __str__(self):
        return self.id

source/webapp/forms.py
from django import forms
from webapp.models import Book, Order, Publisher, Request, RequestBook

class BookForm(forms.ModelForm):
    class Meta:
        model = Book
        exclude = []

class OrderForm(forms.ModelForm):
    class Meta:
        model = Order
        exclude = []

class RequestBookForm(forms.ModelForm):
    class Meta:
        model = RequestBook
        exclude = ['request']

class PublisherForm(forms.ModelForm):
    class Meta:
        model = Publisher
        exclude = []

class RequestForm(forms.ModelForm):
    class Meta:
        model = Request
        exclude = []

source/webapp/views.py
from django.shortcuts import render
from django.views.generic import DetailView, CreateView, UpdateView, ListView, DeleteView
from django.urls import reverse, reverse_lazy
from django.http import HttpResponse, HttpResponseRedirect, JsonResponse
from webapp.models import Book, Order, Publisher, Request, RequestBook
from webapp.forms import OrderForm, BookForm, RequestBookForm, PublisherForm, RequestForm
from collections import Counter


class BookDetailView(DetailView):
    model = Book
    template_name = 'book_detail.html'

class BookCreateView(CreateView):
    model = Book
    template_name = 'book_create.html'
    form_class = BookForm

    def get_success_url(self):
        return reverse('webapp:book_detail', kwargs={'pk': self.object.pk})

class BookUpdateView(UpdateView):
    model = Book
    template_name = 'book_update.html'
    form_class = BookForm

    def get_success_url(self):
        return reverse('webapp:book_detail', kwargs={'pk': self.object.pk})

class BookDeleteView(DeleteView):
    model = Book
    template_name = 'book_delete.html'

    def get_success_url(self):
        return reverse('webapp:book_list')

class BookListView(ListView):
    model = Book
    template_name = 'index.html'

class OrderDetailView(DetailView):
    model = Order
    template_name = 'order_detail.html'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['orderbooks'] = RequestBook.objects.filter(book__publisher=self.object.publisher)
        list = []
        for orderbook in context['orderbooks']:
            list.append(orderbook.book.id)
        a = set(list)
        context['list'] = a
        context['len'] = len(list)

        for orderbook in context['orderbooks']:
            if orderbook.book.id in list:
                amount = orderbook.amount
                amount += orderbook.amount
                context['amount'] = amount

        return context


class OrderListView(ListView):
    model = Order
    template_name = 'order_list.html'



class OrderCreateView(CreateView):
    model = Order
    template_name = 'order_create.html'
    form_class = OrderForm

    def get_success_url(self):
        return reverse('webapp:order_detail', kwargs={'pk': self.object.pk})


class OrderUpdateView(UpdateView):
    model = Order
    template_name = 'order_update.html'
    form_class = OrderForm


    def get_success_url(self):
        return reverse('webapp:order_detail', kwargs={'pk': self.object.pk})

# class OrderBookCreateView(CreateView):
#     model = OrderBook
#     form_class = OrderBookForm
#     template_name = 'order_book_create.html'
#
#     def get_success_url(self):
#         return reverse('webapp:order_detail', kwargs={'pk': self.object.order.pk})
#
#     def get_context_data(self, **kwargs):
#         context = super().get_context_data(**kwargs)
#         context['order'] = Order.objects.get(pk=self.kwargs.get('pk'))
#         return context
#
#     def form_valid(self, form):
#         form.instance.order = Order.objects.get(pk=self.kwargs.get('pk'))
#         return super().form_valid(form)
#
# class OrderBookUpdateView(UpdateView):
#     model = OrderBook
#     form_class = OrderBookForm
#     template_name = 'order_book_update.html'
#
#     def get_success_url(self):
#         return reverse('webapp:order_detail', kwargs={'pk': self.object.order.pk})
#
# class OrderBookDeleteView(DeleteView):
#     model = OrderBook
#     template_name = 'order_book_delete.html'
#
#     def get_success_url(self):
#         return reverse('webapp:order_detail', kwargs={'pk': self.object.order.pk})

class PublisherDetailView(DetailView):
    model = Publisher
    template_name = 'publisher_detail.html'


class PublisherListView(ListView):
    model = Publisher
    template_name = 'publisher_list.html'

class PublisherCreateView(CreateView):
    model = Publisher
    template_name = 'publisher_create.html'
    form_class = PublisherForm

    def get_success_url(self):
        return reverse('webapp:publisher_detail', kwargs={'pk': self.object.pk})

class PublisherUpdateView(UpdateView):
    model = Publisher
    template_name = 'publisher_update.html'
    form_class = PublisherForm

    def get_success_url(self):
        return reverse('webapp:publisher_detail', kwargs={'pk': self.object.pk})

class PublisherDeleteView(DeleteView):
    model = Publisher
    template_name = 'publisher_delete.html'


    def get_success_url(self):
        return reverse('webapp:publisher_list')

class RequestDetailView(DetailView):
    model = Request
    template_name = 'request_detail.html'


class RequestListView(ListView):
    model = Request
    template_name = 'request_list.html'


class RequestCreateView(CreateView):
    model = Request
    template_name = 'request_create.html'
    form_class = RequestForm

    def get_success_url(self):
        return reverse('webapp:request_detail', kwargs={'pk': self.object.pk})

class RequestBookCreateView(CreateView):
    model = RequestBook
    form_class = RequestBookForm
    template_name = 'request_book_create.html'

    def get_success_url(self):
        return reverse('webapp:request_detail', kwargs={'pk': self.object.request.pk})

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['request'] = Request.objects.get(pk=self.kwargs.get('pk'))
        return context

    def form_valid(self, form):
        form.instance.request = Request.objects.get(pk=self.kwargs.get('pk'))
        return super().form_valid(form)

source/webapp/templates/book_create.html
{% extends 'base.html' %}
{% block title %}Добавить книгу{% endblock %}
{% block content %}
    <h4>Добавить книгу:</h4>
    <form action="{% url 'webapp:book_create' %}" method="post" enctype="multipart/form-data">
        {% csrf_token %}
        {{ form.as_p }}
        <button type="submit" class="btn btn-dark">Сохранить</button>
    </form>
{% endblock %}

source/webapp/templates/book_delete.html
{% extends 'base.html' %}

{% block title %}Удалить книгу{% endblock %}

{% block content %}
    <h1>Удалить книгу</h1>
    <h5>Вы уверены, что хотите удалить книгу "{{ book.title }}"?</h5>
    <form action="{% url 'webapp:book_delete' book.pk %}" method="post">
        {% csrf_token %}
        <button type="submit" class="btn btn-danger">Удалить</button>
    </form>
{% endblock %}

source/webapp/templates/book_detail.html
{% extends 'base.html' %}
{% block title %}Книга{% endblock %}
{% block content %}
    <div class="m-3">
        <p>Название: {{ book.title }}</p>
        <p>Описание: {{ book.description }}</p>
        <p>Версия: {{ book.type }}</p>
        <p>Автор: {{ book.author }}</p>
        <p>Издательство: {{ book.publisher.name }}</p>
        {% if book.amount > 0 %}
        <p>Количество: {{ book.amount }}</p>
        {% endif %}
            <a class="btn btn-dark" href="{% url 'webapp:book_delete' book.pk %}">Удалить книгу</a>
            <a class="btn btn-dark" href="{% url 'webapp:book_update' book.pk %}">Изменить книгу</a>
    </div>
{% endblock %}

source/webapp/templates/book_list.html
{% extends 'base.html' %}
{% block title %}Books{% endblock %}
{% block content %}
    {% for book in book_list %}
        <h4><a href="{% url 'webapp:book_detail' book.pk %}">{{ book.title }}</a></h4>
        <p>{{ book.description }}</p>
        <hr>
    {% endfor %}
{% endblock %}

source/webapp/templates/order_book_create.html
{% extends 'base.html' %}
{% load static %}
{% block title %}Добавить книгу в заказ{% endblock %}

{% block content %}
    <h4>Добавить книгу в заказ:</h4>
        <form action="{% url 'webapp:order_book_create' order.pk %}" method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <button type="submit" class="btn btn-dark">Сохранить</button>
        </form>
{% endblock %}

source/webapp/templates/order_book_delete.html
{% extends 'base.html' %}

{% block title %}Удалить книгу{% endblock %}

{% block content %}
    <h1>Удалить книгу</h1>
    <h5>Вы уверены, что хотите удалить книгу {{ orderbook.pk }} из заказа?</h5>
    <form action="{% url 'webapp:order_book_delete' orderbook.pk %}" method="post">
        {% csrf_token %}
        <button type="submit" class="btn btn-danger">Удалить</button>
    </form>
{% endblock %}

source/webapp/templates/order_book_update.html
{% extends 'base.html' %}
{% load static %}
{% block title %}Изменить заказ{% endblock %}

{% block content %}
    <h4>Изменить состав заказа:</h4>
        <h2>Заказ уже доставляется или доставлен</h2>
        <form action="{% url 'webapp:order_book_update' orderbook.pk %}" method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <button type="submit" class="btn btn-dark">Сохранить</button>
        </form>
{% endblock %}

source/webapp/templates/order_create.html
{% extends 'base.html' %}
{% load static %}
{% block title %}Добавить заказ{% endblock %}
{% block content %}
    <h4>Создать заказ:</h4>
    <form action="{% url 'webapp:order_create' %}" method="post">
        {% csrf_token %}
        {{ formset.media }}
        {{ form.as_p }}

{#        {% for form in formset %}#}
{#            <hr>#}
{#            <div class="ml-5">#}
{#                {{ form.as_p }}#}
{#            </div>#}
{#        {% endfor %}#}

        <button type="submit" class="btn btn-dark">Сохранить</button>
    </form>
{% endblock %}

source/webapp/templates/order_update.html
{% extends 'base.html' %}
{% load static %}
{% block title %}Изменить заказ{% endblock %}

{% block content %}
    <h4>Изменить заказ:</h4>
        <form action="{% url 'webapp:order_update' order.pk %}" method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <button type="submit" class="btn btn-dark">Сохранить</button>
        </form>
{% endblock %}

source/webapp/templates/publisher_create.html
{% extends 'base.html' %}
{% block title %}Добавить издателя{% endblock %}
{% block content %}
    <h4>Добавить издателя:</h4>
    <form action="{% url 'webapp:publisher_create' %}" method="post" enctype="multipart/form-data">
        {% csrf_token %}
        {{ form.as_p }}
        <button type="submit" class="btn btn-dark">Сохранить</button>
    </form>
{% endblock %}

source/webapp/templates/publisher_list.html
{% extends 'base.html' %}
{% block title %}Издатели{% endblock %}
{% block content %}
    {% for publisher in publisher_list %}
        <h4><a href="{% url 'webapp:publisher_detail' publisher.pk %}">{{ publisher.name }}</a></h4>
        <p>{{ publisher.phone }}</p>
        <hr>
    {% endfor %}
{% endblock %}

source/webapp/templates/publisher_update.html
{% extends 'base.html' %}
{% block title %}Изменить данные издателя{% endblock %}
{% block content %}
    <h4>Изменить данные издателя:</h4>
    <form action="{% url 'webapp:publisher_update' form.instance.pk %}" method="post" enctype="multipart/form-data">
        {% csrf_token %}
        {{ form.as_p }}
        <button type="submit" class="btn btn-dark">Сохранить</button>
    </form>
{% endblock %}

source/webapp/templates/request_detail.html
{% extends 'base.html' %}
{% block title %}Заказ{% endblock %}
{% block content %}
    <div class="m-3">
    <p>Заявка №{{ request.id }}</p>
        <p>Статус: {{ request.type }}</p>
        <p><b>Книги:</b></p>
        {% for request_book in request.request_books.all %}
        <p>{{ request_book.book.title }}, количество: {{ request_book.amount }}</p>

{#         <a class="btn btn-dark" href="{% url 'webapp:request_book_update' request_book.pk %}">Изменить книгу</a>#}
{##}
{#        <a class="btn btn-dark" href="{% url 'webapp:request_book_delete' request_book.pk %}">Удалить книгу</a>#}
        {% endfor %}
        <hr>

     <div class="mb-3">
{#            <a class="btn btn-danger" href="{% url 'webapp:request_update' request.pk %}">Изменить детали заказа</a>#}
            <a class="btn btn-danger" href="{% url 'webapp:request_book_create' request.pk %}">Добавить книгу</a>
         <a class="btn btn-danger" href="{% url 'webapp:book_create' %}">Добавить новую книгу</a>


        </div>
    </div>
{% endblock %}

source/webapp/templates/request_list.html
{% extends 'base.html' %}
{% block title %}Заявки{% endblock %}
{% block content %}
    {% for request in request_list %}
        <h4><a href="{% url 'webapp:request_detail' request.pk %}">Заявка №{{ request.id }}</a></h4>
        <p>{{ request.type }} книги "{{ request.request_book.title }}"</p>
        <hr>
    {% endfor %}
{% endblock %}